Index: src/Actions/AnalysisAction/PrincipalAxisSystemAction.cpp
===================================================================
--- src/Actions/AnalysisAction/PrincipalAxisSystemAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/AnalysisAction/PrincipalAxisSystemAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * PrincipalAxisSystemAction.cpp
@@ -6,11 +13,17 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/AnalysisAction/PrincipalAxisSystemAction.hpp"
-#include "Actions/ActionRegistry.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "LinearAlgebra/Matrix.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "element.hpp"
 #include "molecule.hpp"
-#include "log.hpp"
-#include "verbose.hpp"
 
 #include <iostream>
@@ -19,37 +32,39 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/AnalysisAction/PrincipalAxisSystemAction.hpp"
 
-const char AnalysisPrincipalAxisSystemAction::NAME[] = "principal-axis-system";
+// and construct the stuff
+#include "PrincipalAxisSystemAction.def"
+#include "Action_impl_pre.hpp"
 
-AnalysisPrincipalAxisSystemAction::AnalysisPrincipalAxisSystemAction() :
-  Action(NAME)
-{}
+/** =========== define the function ====================== */
+Action::state_ptr AnalysisPrincipalAxisSystemAction::performCall() {
+  Matrix InertiaTensor;
 
-AnalysisPrincipalAxisSystemAction::~AnalysisPrincipalAxisSystemAction()
-{}
-
-void AnalysisPrincipalAxisSystem() {
-  ActionRegistry::getInstance().getActionByName(AnalysisPrincipalAxisSystemAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* AnalysisPrincipalAxisSystemAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-Action::state_ptr AnalysisPrincipalAxisSystemAction::performCall() {
-  molecule *mol = NULL;
-
-  ValueStorage::getInstance().queryCurrentValue(NAME, mol);
   DoLog(0) && (Log() << Verbose(0) << "Evaluating prinicipal axis." << endl);
   for (World::MoleculeSelectionIterator iter = World::getInstance().beginMoleculeSelection(); iter != World::getInstance().endMoleculeSelection(); ++iter) {
     molecule *mol = iter->second;
-    mol->PrincipalAxisSystem(false);
+    Vector *CenterOfGravity = mol->DetermineCenterOfGravity();
+
+    // reset inertia tensor
+    InertiaTensor.zero();
+
+    // sum up inertia tensor
+    for (molecule::const_iterator iter = mol->begin(); iter != mol->end(); ++iter) {
+      Vector x = (*iter)->getPosition();
+      x -= *CenterOfGravity;
+      const double mass = (*iter)->getType()->getMass();
+      InertiaTensor.at(0,0) += mass*(x[1]*x[1] + x[2]*x[2]);
+      InertiaTensor.at(0,1) += mass*(-x[0]*x[1]);
+      InertiaTensor.at(0,2) += mass*(-x[0]*x[2]);
+      InertiaTensor.at(1,0) += mass*(-x[1]*x[0]);
+      InertiaTensor.at(1,1) += mass*(x[0]*x[0] + x[2]*x[2]);
+      InertiaTensor.at(1,2) += mass*(-x[1]*x[2]);
+      InertiaTensor.at(2,0) += mass*(-x[2]*x[0]);
+      InertiaTensor.at(2,1) += mass*(-x[2]*x[1]);
+      InertiaTensor.at(2,2) += mass*(x[0]*x[0] + x[1]*x[1]);
+    }
+    // print InertiaTensor for debugging
+    DoLog(0) && (Log() << Verbose(0) << "The inertia tensor is:" << InertiaTensor << endl);
   }
   return Action::success;
@@ -75,2 +90,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/AnalysisAction/PrincipalAxisSystemAction.def
===================================================================
--- src/Actions/AnalysisAction/PrincipalAxisSystemAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/AnalysisAction/PrincipalAxisSystemAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,17 @@
+/*
+ * PrincipalAxisSystemAction.def
+ *
+ *  Created on: Aug 25, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Analysis
+#define ACTIONNAME PrincipalAxisSystem
+#define TOKEN "principal-axis-system"
Index: src/Actions/AnalysisAction/PrincipalAxisSystemAction.hpp
===================================================================
--- src/Actions/AnalysisAction/PrincipalAxisSystemAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/AnalysisAction/PrincipalAxisSystemAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -11,26 +11,6 @@
 #include "Actions/Action.hpp"
 
-void AnalysisPrincipalAxisSystem();
-
-class AnalysisPrincipalAxisSystemAction : public Action {
-  friend void AnalysisPrincipalAxisSystem();
-
-public:
-  AnalysisPrincipalAxisSystemAction();
-  virtual ~AnalysisPrincipalAxisSystemAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "PrincipalAxisSystemAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* PRINCIPALAXISSYSTEMACTION_HPP_ */
Index: src/Actions/AnalysisAction/SurfaceCorrelationAction.cpp
===================================================================
--- src/Actions/AnalysisAction/SurfaceCorrelationAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/AnalysisAction/SurfaceCorrelationAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * SurfaceCorrelationAction.cpp
@@ -6,17 +13,21 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/AnalysisAction/SurfaceCorrelationAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "analysis_correlation.hpp"
 #include "boundary.hpp"
 #include "linkedcell.hpp"
-#include "verbose.hpp"
-#include "log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "Helpers/Log.hpp"
 #include "element.hpp"
 #include "molecule.hpp"
 #include "periodentafel.hpp"
-#include "vector.hpp"
+#include "tesselation.hpp"
+#include "LinearAlgebra/Vector.hpp"
 #include "World.hpp"
 
@@ -26,80 +37,30 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/AnalysisAction/SurfaceCorrelationAction.hpp"
 
-const char AnalysisSurfaceCorrelationAction::NAME[] = "surface-correlation";
+// and construct the stuff
+#include "SurfaceCorrelationAction.def"
+#include "Action_impl_pre.hpp"
 
-AnalysisSurfaceCorrelationAction::AnalysisSurfaceCorrelationAction() :
-  Action(NAME)
-{}
-
-AnalysisSurfaceCorrelationAction::~AnalysisSurfaceCorrelationAction()
-{}
-
-void AnalysisSurfaceCorrelation(std::vector< element *> &elements, molecule *mol, double BinStart, double BinWidth, double BinEnd, std::string &outputname, std::string &binoutputname, bool periodic) {
-  ValueStorage::getInstance().setCurrentValue("elements", elements);
-  ValueStorage::getInstance().setCurrentValue("molecule-by-id", mol);
-  ValueStorage::getInstance().setCurrentValue("bin-start", BinStart);
-  ValueStorage::getInstance().setCurrentValue("bin-width", BinWidth);
-  ValueStorage::getInstance().setCurrentValue("bin-end", BinEnd);
-  ValueStorage::getInstance().setCurrentValue("output-file", outputname);
-  ValueStorage::getInstance().setCurrentValue("bin-output-file", binoutputname);
-  ValueStorage::getInstance().setCurrentValue("periodic", periodic);
-  ActionRegistry::getInstance().getActionByName(AnalysisSurfaceCorrelationAction::NAME)->call(Action::NonInteractive);
-};
-
-
-Dialog* AnalysisSurfaceCorrelationAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryMolecule("molecule-by-id", ValueStorage::getInstance().getDescription("molecule-by-id"));
-  dialog->queryElements("elements", ValueStorage::getInstance().getDescription("elements"));
-  dialog->queryDouble("bin-start", ValueStorage::getInstance().getDescription("bin-start"));
-  dialog->queryDouble("bin-width", ValueStorage::getInstance().getDescription("bin-width"));
-  dialog->queryDouble("bin-end", ValueStorage::getInstance().getDescription("bin-end"));
-  dialog->queryString("output-file", ValueStorage::getInstance().getDescription("output-file"));
-  dialog->queryString("bin-output-file", ValueStorage::getInstance().getDescription("bin-output-file"));
-  dialog->queryBoolean("periodic", ValueStorage::getInstance().getDescription("periodic"));
-
-  return dialog;
-}
-
+/** =========== define the function ====================== */
 Action::state_ptr AnalysisSurfaceCorrelationAction::performCall() {
   int ranges[3] = {1, 1, 1};
-  double BinEnd = 0.;
-  double BinStart = 0.;
-  double BinWidth = 0.;
-  molecule *Boundary = NULL;
-  string outputname;
-  string binoutputname;
-  bool periodic;
   ofstream output;
   ofstream binoutput;
-  std::vector< element *> elements;
   string type;
-  Vector Point;
   BinPairMap *binmap = NULL;
 
   // obtain information
-  ValueStorage::getInstance().queryCurrentValue("molecule-by-id", Boundary);
-  ValueStorage::getInstance().queryCurrentValue("elements", elements);
-  ValueStorage::getInstance().queryCurrentValue("bin-start", BinStart);
-  ValueStorage::getInstance().queryCurrentValue("bin-width", BinWidth);
-  ValueStorage::getInstance().queryCurrentValue("bin-end", BinEnd);
-  ValueStorage::getInstance().queryCurrentValue("output-file", outputname);
-  ValueStorage::getInstance().queryCurrentValue("bin-output-file", binoutputname);
-  ValueStorage::getInstance().queryCurrentValue("periodic", periodic);
+  getParametersfromValueStorage();
 
   // execute action
-  output.open(outputname.c_str());
-  binoutput.open(binoutputname.c_str());
-  ASSERT(Boundary != NULL, "No molecule specified for SurfaceCorrelation.");
+  output.open(params.outputname.c_str());
+  binoutput.open(params.binoutputname.c_str());
+  ASSERT(params.Boundary != NULL, "No molecule specified for SurfaceCorrelation.");
   const double radius = 4.;
   double LCWidth = 20.;
-  if (BinEnd > 0) {
-    if (BinEnd > 2.*radius)
-      LCWidth = BinEnd;
+  if (params.BinEnd > 0) {
+    if (params.BinEnd > 2.*radius)
+      LCWidth = params.BinEnd;
     else
       LCWidth = 2.*radius;
@@ -111,12 +72,12 @@
   // find biggest molecule
   std::vector<molecule*> molecules = World::getInstance().getSelectedMolecules();
-  int counter  = molecules.size();
-  LCList = new LinkedCell(Boundary, LCWidth);
-  FindNonConvexBorder(Boundary, TesselStruct, LCList, radius, NULL);
+  std::cout << "There are " << molecules.size() << " selected molecules." << std::endl;
+  LCList = new LinkedCell(*params.Boundary, LCWidth);
+  FindNonConvexBorder(params.Boundary, TesselStruct, LCList, radius, NULL);
   CorrelationToSurfaceMap *surfacemap = NULL;
-  if (periodic)
-    surfacemap = PeriodicCorrelationToSurface( molecules, elements, TesselStruct, LCList, ranges);
+  if (params.periodic)
+    surfacemap = PeriodicCorrelationToSurface( molecules, params.elements, TesselStruct, LCList, ranges);
   else
-    surfacemap = CorrelationToSurface( molecules, elements, TesselStruct, LCList);
+    surfacemap = CorrelationToSurface( molecules, params.elements, TesselStruct, LCList);
   delete LCList;
   OutputCorrelationToSurface(&output, surfacemap);
@@ -128,5 +89,5 @@
       DoeLog(1) && (eLog()<< Verbose(1) << "Linked Cell width is smaller than the found range of values! Bins can only be correct up to: " << radius << "." << endl);
   }
-  binmap = BinData( surfacemap, BinWidth, BinStart, BinEnd );
+  binmap = BinData( surfacemap, params.BinWidth, params.BinStart, params.BinEnd );
   OutputCorrelation ( &binoutput, binmap );
   delete TesselStruct;  // surfacemap contains refs to triangles! delete here, not earlier!
@@ -157,2 +118,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/AnalysisAction/SurfaceCorrelationAction.def
===================================================================
--- src/Actions/AnalysisAction/SurfaceCorrelationAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/AnalysisAction/SurfaceCorrelationAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,24 @@
+/*
+ * SurfaceCorrelationAction.def
+ *
+ *  Created on: Aug 25, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include <string>
+#include <vector>
+class element;
+class molecule;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (std::vector<const element *>)(molecule *)(double)(double)(double)(std::string)(std::string)(bool)
+#define paramreferences (elements)(Boundary)(BinStart)(BinWidth)(BinEnd)(outputname)(binoutputname)(periodic)
+#define paramtokens ("elements")("molecule-by-id")("bin-start")("bin-width")("bin-end")("output-file")("bin-output-file")("periodic")
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Analysis
+#define ACTIONNAME SurfaceCorrelation
+#define TOKEN "surface-correlation"
Index: src/Actions/AnalysisAction/SurfaceCorrelationAction.hpp
===================================================================
--- src/Actions/AnalysisAction/SurfaceCorrelationAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/AnalysisAction/SurfaceCorrelationAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -10,31 +10,7 @@
 
 #include "Actions/Action.hpp"
-#include <string>
-#include <vector>
 
-class element;
-class molecule;
-
-void AnalysisSurfaceCorrelation(std::vector< element *> &elements, molecule *mol, double BinStart, double BinWidth, double BinEnd, std::string &outputname, std::string &binoutputname, bool periodic);
-
-class AnalysisSurfaceCorrelationAction : public Action {
-  friend void AnalysisSurfaceCorrelation(std::vector< element *> &elements, molecule *mol, double BinStart, double BinWidth, double BinEnd, std::string &outputname, std::string &binoutputname, bool periodic);
-public:
-  AnalysisSurfaceCorrelationAction();
-  virtual ~AnalysisSurfaceCorrelationAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog*);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "SurfaceCorrelationAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* SURFACECORRELATIONACTION_HPP_ */
Index: src/Actions/AtomAction/AddAction.cpp
===================================================================
--- src/Actions/AtomAction/AddAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/AtomAction/AddAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * AddAction.cpp
@@ -6,14 +13,18 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/AtomAction/AddAction.hpp"
-#include "Actions/ActionRegistry.hpp"
+#include "Descriptors/AtomIdDescriptor.hpp"
 #include "atom.hpp"
 #include "element.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
 #include "molecule.hpp"
-#include "vector.hpp"
-#include "verbose.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Helpers/Verbose.hpp"
 #include "World.hpp"
 
@@ -23,45 +34,19 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/AtomAction/AddAction.hpp"
 
-const char AtomAddAction::NAME[] = "add-atom";
-
-AtomAddAction::AtomAddAction() :
-  Action(NAME)
-{}
-
-AtomAddAction::~AtomAddAction()
-{}
-
-void AtomAdd(element *elemental, Vector &position) {
-  ValueStorage::getInstance().setCurrentValue(AtomAddAction::NAME, elemental);
-  ValueStorage::getInstance().setCurrentValue("position", elemental);
-  ActionRegistry::getInstance().getActionByName(AtomAddAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog * AtomAddAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryElement(NAME, ValueStorage::getInstance().getDescription(NAME));
-  dialog->queryVector("position", true, ValueStorage::getInstance().getDescription("position"));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "AddAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr AtomAddAction::performCall() {
-  element * elemental = NULL;
-  Vector position;
-
   // obtain information
-  ValueStorage::getInstance().queryCurrentValue(NAME, elemental);
-  ValueStorage::getInstance().queryCurrentValue("position", position);
+  getParametersfromValueStorage();
 
   // execute action
   atom * first = World::getInstance().createAtom();
-  first->type = elemental;
-  first->x = position;
-  DoLog(1) && (Log() << Verbose(1) << "Adding new atom with element " << first->type->name << " at " << (first->x) << "." << endl);
+  first->setType(params.elemental);
+  first->setPosition(params.position);
+  DoLog(1) && (Log() << Verbose(1) << "Adding new atom with element " << first->getType()->getName() << " at " << (first->getPosition()) << "." << endl);
   // TODO: remove when all of World's atoms are stored.
   std::vector<molecule *> molecules = World::getInstance().getAllMolecules();
@@ -70,27 +55,41 @@
     (*iter)->AddAtom(first);
   }
-  return Action::success;
+  return Action::state_ptr(new AtomAddState(first->getId(), params));
 }
 
 Action::state_ptr AtomAddAction::performUndo(Action::state_ptr _state) {
-//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+  AtomAddState *state = assert_cast<AtomAddState*>(_state.get());
 
-  return Action::failure;
-//  string newName = state->mol->getName();
-//  state->mol->setName(state->lastName);
-//
-//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+  DoLog(1) && (Log() << Verbose(1) << "Removing atom with id " << state->id << "." << endl);
+  World::getInstance().destroyAtom(state->id);
+
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr AtomAddAction::performRedo(Action::state_ptr _state){
-  return Action::failure;
+  AtomAddState *state = assert_cast<AtomAddState*>(_state.get());
+
+  atom * first = World::getInstance().createAtom();
+  first->setType(state->params.elemental);
+  first->setPosition(state->params.position);
+  DoLog(1) && (Log() << Verbose(1) << "Re-adding new atom with element " << state->params.elemental->getName() << " at " << state->params.position << "." << endl);
+  // TODO: remove when all of World's atoms are stored.
+  std::vector<molecule *> molecules = World::getInstance().getAllMolecules();
+  if (!molecules.empty()) {
+    std::vector<molecule *>::iterator iter = molecules.begin();
+    (*iter)->AddAtom(first);
+  }
+  if (first->getId() != state->id)
+    if (!first->changeId(state->id))
+      return Action::failure;
+  return Action::state_ptr(_state);
 }
 
 bool AtomAddAction::canUndo() {
-  return false;
+  return true;
 }
 
 bool AtomAddAction::shouldUndo() {
-  return false;
+  return true;
 }
 
@@ -98,2 +97,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/AtomAction/AddAction.def
===================================================================
--- src/Actions/AtomAction/AddAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/AtomAction/AddAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,26 @@
+/*
+ * AddAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+#include "LinearAlgebra/BoxVector.hpp"
+#include "World.hpp"
+class element;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (const element *)(BoxVector)
+#define paramtokens (ACTION::NAME)("position")
+#define paramreferences (elemental)(position)
+
+#define statetypes (const atomId_t)
+#define statereferences (id)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Atom
+#define ACTIONNAME Add
+#define TOKEN "add-atom"
Index: src/Actions/AtomAction/AddAction.hpp
===================================================================
--- src/Actions/AtomAction/AddAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/AtomAction/AddAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -10,30 +10,7 @@
 
 #include "Actions/Action.hpp"
-#include "vector.hpp"
 
-class element;
-
-void AtomAdd(element *elemental, Vector &position);
-
-class AtomAddAction : public Action {
-  friend void AtomAdd(element *elemental, Vector &position);
-
-public:
-  AtomAddAction();
-  virtual ~AtomAddAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "AddAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* ADDACTION_HPP_ */
Index: src/Actions/AtomAction/ChangeElementAction.cpp
===================================================================
--- src/Actions/AtomAction/ChangeElementAction.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/AtomAction/ChangeElementAction.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * ChangeElementAction.cpp
@@ -6,80 +13,95 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/AtomAction/ChangeElementAction.hpp"
-#include "Actions/ActionRegistry.hpp"
+#include "Descriptors/AtomIdDescriptor.hpp"
 #include "atom.hpp"
 #include "element.hpp"
-#include "log.hpp"
-#include "vector.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "LinearAlgebra/Vector.hpp"
+#include "Helpers/Verbose.hpp"
+#include "molecule.hpp"
 #include "World.hpp"
 
 #include <iostream>
+#include <map>
 #include <string>
 
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/AtomAction/ChangeElementAction.hpp"
 
-const char AtomChangeElementAction::NAME[] = "change-element";
-
-AtomChangeElementAction::AtomChangeElementAction() :
-  Action(NAME)
-{}
-
-AtomChangeElementAction::~AtomChangeElementAction()
-{}
-
-void AtomChangeElement(element *elemental) {
-  ValueStorage::getInstance().setCurrentValue(AtomChangeElementAction::NAME, elemental);
-  ActionRegistry::getInstance().getActionByName(AtomChangeElementAction::NAME)->call(Action::NonInteractive);
-};
-
-Dialog* AtomChangeElementAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryElement(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-return dialog;
-}
-
+// and construct the stuff
+#include "ChangeElementAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr AtomChangeElementAction::performCall() {
   atom *first = NULL;
-  element *elemental = NULL;
+  molecule *mol = NULL;
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, elemental);
+  // obtain information
+  getParametersfromValueStorage();
+
+  // create undo state
+  ElementMap Elements;
+  for (World::AtomSelectionIterator iter = World::getInstance().beginAtomSelection(); iter != World::getInstance().endAtomSelection(); ++iter) {
+    Elements.insert(std::pair<int, const element *> (iter->second->getId(), iter->second->getType()));
+  }
+  AtomChangeElementState *UndoState = new AtomChangeElementState(Elements, params);
 
   for (World::AtomSelectionIterator iter = World::getInstance().beginAtomSelection(); iter != World::getInstance().endAtomSelection(); ++iter) {
     first = iter->second;
-    DoLog(1) && (Log() << Verbose(1) << "Changing atom " << *first << " to element " << elemental->symbol << "." << endl);
-    first->type = elemental;
+    DoLog(1) && (Log() << Verbose(1) << "Changing atom " << *first << " to element " << *params.elemental << "." << endl);
+    mol = first->getMolecule();
+    first->removeFromMolecule(); // remove atom
+    first->setType(params.elemental);
+    mol->AddAtom(first);  // add atom to ensure correctness of formula
   }
-  return Action::success;
+  return Action::state_ptr(UndoState);
 }
 
 Action::state_ptr AtomChangeElementAction::performUndo(Action::state_ptr _state) {
-//  ParserLoadXyzState *state = assert_cast<ParserLoadXyzState*>(_state.get());
+  AtomChangeElementState *state = assert_cast<AtomChangeElementState*>(_state.get());
+  atom *first = NULL;
+  molecule *mol = NULL;
 
-  return Action::failure;
-//  string newName = state->mol->getName();
-//  state->mol->setName(state->lastName);
-//
-//  return Action::state_ptr(new ParserLoadXyzState(state->mol,newName));
+  for(ElementMap::const_iterator iter = state->Elements.begin(); iter != state->Elements.end(); ++iter) {
+    first = World::getInstance().getAtom(AtomById(iter->first));
+    mol = first->getMolecule();
+    first->removeFromMolecule(); // remove atom
+    first->setType(iter->second);
+    mol->AddAtom(first);  // add atom to ensure correctness of formula
+  }
+
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr AtomChangeElementAction::performRedo(Action::state_ptr _state){
-  return Action::failure;
+  AtomChangeElementState *state = assert_cast<AtomChangeElementState*>(_state.get());
+  atom *first = NULL;
+  molecule *mol = NULL;
+
+  for(ElementMap::const_iterator iter = state->Elements.begin(); iter != state->Elements.end(); ++iter) {
+    first = World::getInstance().getAtom(AtomById(iter->first));
+    mol = first->getMolecule();
+    first->removeFromMolecule(); // remove atom
+    first->setType(state->params.elemental);
+    mol->AddAtom(first);  // add atom to ensure correctness of formula
+  }
+
+  return Action::state_ptr(_state);
 }
 
 bool AtomChangeElementAction::canUndo() {
-  return false;
+  return true;
 }
 
 bool AtomChangeElementAction::shouldUndo() {
-  return false;
+  return true;
 }
 
@@ -87,2 +109,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/AtomAction/ChangeElementAction.def
===================================================================
--- src/Actions/AtomAction/ChangeElementAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/AtomAction/ChangeElementAction.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,25 @@
+/*
+ * ChangeElementAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class element;
+typedef std::map<int, const element *> ElementMap;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (const element *)
+#define paramtokens (ACTION::NAME)
+#define paramreferences (elemental)
+
+#define statetypes (ElementMap)
+#define statereferences (Elements)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Atom
+#define ACTIONNAME ChangeElement
+#define TOKEN "change-element"
Index: src/Actions/AtomAction/ChangeElementAction.hpp
===================================================================
--- src/Actions/AtomAction/ChangeElementAction.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/AtomAction/ChangeElementAction.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -9,30 +9,9 @@
 #define CHANGELEMENTACTION_HPP_
 
+
 #include "Actions/Action.hpp"
 
-class element;
-
-void AtomChangeElement(element *elemental);
-
-class AtomChangeElementAction : public Action {
-  friend void AtomChangeElement(element *elemental);
-
-public:
-  AtomChangeElementAction();
-  virtual ~AtomChangeElementAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog*);
-private:
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "ChangeElementAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* CHANGELEMENTACTION_HPP_ */
Index: src/Actions/AtomAction/Remove.def
===================================================================
--- src/Actions/AtomAction/Remove.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/AtomAction/Remove.def	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,27 @@
+/*
+ * Remove.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+#include "Actions/Action.hpp"
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+
+
+
+
+
+
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Atom
+#define ACTIONNAME Remove
+#define TOKEN ""remove-atom";"
+
+EOF;
